\scheda{coord}
\tipo{S}
\scopo
Definisce il sistema di coordinate dell'$\,$utente.

\ccall
coord(k)
int k;
\endccall

\param
\prm{k}Variabile o costante intera che specifica il
sistema di coordinate scelto. Pu\`o assumere i valori:
\paritm{1}coordinate lineari
\paritm{2}il solo asse $x$ \`e logaritmico, mentre $y$ resta 
lineare;
\paritm{3}il solo asse $y$ \`e logaritmico, mentre $x$ resta lineare;
\paritm{4}entrambi gli assi sono
logaritmici;
\paritm{5}coordinate polari.
\valdef
Vengono usate coordinate lineari ({\tt k}=1).

\conderr
\errit{LGE\_SISTCOORD}Il valore specificato in {\tt k} non \`e uno di
quelli previsti: il sistema di coordinate richiesto non esiste.

\note
In caso di uso delle coordinate polari \`e compito dell'$\,$utente eseguire la 
riduzione degli angoli all'$\,$angolo giro. Eventualmente si pu\`o fare uso del
sottoprogramma {\tt angrid}.

