\scheda{defcen}
\tipo{S}
\scopo
{\corsivo Interattiva:\quad}Definisce, in coordinate grafico,
il punto della pagina che deve corrispondere
al centro dell'$\,$area fisica durante il tracciamento.
\par\noindent
{\corsivo File grafico:\quad}La chiamata non ha alcun effetto sul file
grafico.

\ccall
defcen(gxcen,gycen)
float gxcen,gycen;
\endccall

\param
\prm{gxcen}
\prm{gycen}Variabili o costanti reali contenenti le coordinate
grafico del punto.
\valdef
Il punto viene assunto al centro dell'$\,$area da proiettare, coincidente con
la pagina o specificata mediante il sottoprogramma {\tt defgrl}.
\ina{Sottoprogramma>defgrl}

\limit
Il punto deve essere interno alla pagina. I limiti di quest'$\,$ultima
sono quelli assunti per difetto o specificati mediante il sottoprogramma
{\tt defpag}.
\ina{Sottoprogramma>defgrl}

\note
Il sottoprogramma non ha praticamente alcun effetto se non \`e stato
disabilitato il riscalamento del disegno, in quanto le dimensioni della pagina
vengono automaticamente riscalate in modo da farla rientrare nei limiti fisici.
Si veda a tal proposito il sottoprogramma {\tt defris}. 
\par
Eventuali ridefinizioni della pagina mediante il sottoprogramma {\tt
defpag}
\ina{Sottoprogramma>defpag}
annullano l'$\,$effetto della chiamata, in quanto ristabiliscono i
valori per difetto. Pu\`o quindi essere necessario chiamare nuovamente
il sottoprogramma dopo aver stabilito i limiti della pagina.
\par
La stessa osservazione vale se vengono ridefiniti i limiti dell'$\,$area
da proiettare mediante il sottoprogramma {\tt defgrl}.
\ina{Sottoprogramma>defgrl}

