\scheda{defdrs}
\tipo{S}
\scopo
Definisce e scrive su file la dimensione e l'$\,$angolo di rotazione
per caratteri e stringhe alfanumeriche.

\ccall
int defdrs(dim,rot);
float dim,rot;
\endccall

\val
In caso di esecuzione corretta viene restituito zero; in caso di errore viene 
restituito uno dei codici riportati sotto. 

\param
\prm{dim}Variabile o costante reale contenente la
dimensione del carattere.
\prm{rot}Variabile o costante reale contenente
l'$\,$angolo di rotazione, nelle unit\`a di misura correnti.

\valdef
La dimensione \`e 1; l'$\,$angolo di rotazione \`e 0.

\limit
La dimensione del carattere deve essere positiva ed inferiore a
255. Se ${\tt dim}=0$ la dimensione viene posta 1; se ${\tt dim}< 0$ ne 
viene preso il valore assoluto; se ${\tt dim}> 255$ la dimensione viene 
posta a 255.

\conderr
\errit{LGE\_DIMCARATT}La dimensione specificata per i caratteri non 
rispetta le limitazioni richieste.


