\scheda{defgrl}
\tipo{S}

\scopo
{\corsivo Interattiva:\quad}Definisce un rettangolo entro la pagina che
deve essere proiettato sull'$\,$area fisica.
\par\noindent
{\corsivo File grafico:\quad}La chiamata non ha alcun effetto sul file
grafico.

\ccall
defgrl(gxmin,gxmax,gymin,gymax)
float gxmin,gxmax,gymin,gymax;
\endccall

\param
\prm{gxmin}
\prm{gxmax}
\prm{gymin}
\prm{gymax}Variabili o costanti reali contenenti i limiti dell'$\,$area
in coordinate grafico.
\valdef
I limiti coincidono con quelli della pagina.
\limit
Devono essere verificate le condizioni 
$$
{\tt gxmin}<{\tt gxmax}, {\tt
gymin}<{\tt gymax}\ .
$$ 
Inoltre il rettangolo delimitato da questi estremi
deve essere contenuto nella pagina.
\conderr
\errit{34}Gli estremi specificati non rispettano le limitazioni richieste.

\note
\`E opportuno, se si usa questo sottoprogramma, abilitare il
riscalamento automatico del disegno, per evitare il taglio di parti che
non sono contenute nell'$\,$area fisica.
\par
Eventuali ridefinizioni della pagina mediante il sottoprogramma {\tt 
defpag}
\ina{Sottoprogramma>defpag}
annullano l'$\,$effetto della chiamata, in quanto fanno coincidere
il rettangolo da proiettare con la pagina stessa.
Pu\`o quindi essere necessario chiamare il sottoprogramma dopo aver
definito i limiti della pagina.

