\scheda{defpen}
\tipo{S}
\scopo
{\corsivo Interattiva:\quad}Stabilisce la corrispondenza tra numero di
penna logica (specificato nella chiamata al sottoprogramma {\tt penna}) e
numero di penna fisica (del plotter) da utilizzare.
\par\noindent
{\corsivo File grafico:\quad}La chiamata non ha alcun effetto sul file grafico.

\ccall
defpen(kplog,kpfis)
int kplog,kpfis;
\endccall

\param
\prm{kplog}Variabile o costante intera contenente il numero di penna logica,
usato nella chiamata al sottoprogramma {\tt penna}.
\prm{kpfis}Variabile o costante intera contenente il numero di penna fisica.
\valdef
La corrispondenza dipende dal periferico. Si veda il manuale dei
periferici.
\limit
Il numero di penna logica ({\tt kplog}) deve essere positivo ed inferiore a 256.
\par
Il numero di penna fisica ({\tt kpfis}) deve essere positivo ed al pi\'u eguale
al numero di penne del periferico. In ogni caso viene ricalcolato
come mod({\tt kpfis}-1,n)+1, dove n \`e il numero di penne del plotter.
Se {\tt kpfis} \`e negativo si assume il valore assoluto;
se \`e 0, si assume 1.
\conderr
\errit{LGE\_PENNA}La penna specificata in {\tt kplog} non \`e prevista.

