\scheda{grcer}
\tipo{S}

\scopo
Traccia un\:ellisse in coordinate grafico, centrata nella posizione 
corrente della penna, con semiasse maggiore, eccentricit\`a e angolo
del pericentro assegnati. 


\ccall
grellisse(double sas,double ecc, double psi,int modo,int *motr)
\endccall

\param
\prm{raggio}Variabile o costante reale che specifica il semiasse maggiore
dell\:ellisse, in unit\`a grafiche.
\prm{psi}Variabile o costante reale che specifica ls direzione del
pericentro nell\:unit\`a corrente degli angoli, misurata rispetto alla
direzione positiva dell\:asse orizzontale.
\prm{modo}Variabile o costante intera che specifica la modalit\`a di 
tracciamento. Pu\`o assumere i valori:
\paritm{$\ge$0}tracciamento a linea continua;
\paritm{$<0$}linea tratteggiata.
\prm{motr}Vettore intero di al pi\'u 11 elementi, che specifica la 
modalit\`a di tratteggio: si veda la scheda del sottoprogramma {\tt 
grtra}.

\conderr
\errit{LGE\_WRONGECC}L'eccentricit\`a non rispetta i limiti $0\le e\lt
1$. La chiamata viene ignorata.

\note
Alla fine del tracciamento la penna viene riposizionata al punto 
iniziale (al centro della circonferenza).

