#! /bin/bash
# Salvataggio su dischetto zip 
if [ ! -d /fd/mizar ]; then
	 mkdir /fd/mizar
fi
cp -afvu salvazip.sh /fd/mizar
cp -afvu Istruzioni.txt /fd/mizar
#
if [ ! -d /fd/mizar/lib ]; then
	 mkdir /fd/mizar/lib
fi
cp -avfu lib/mizar.h /fd/mizar/lib/
cp -avfu lib/bldcom /fd/mizar/lib/
cp -avfu lib/bldfil /fd/mizar/lib/
cp -avfu lib/bldint /fd/mizar/lib/
#
if [ ! -d /fd/mizar/src ]; then
	 mkdir /fd/mizar/src
fi
cp -avfu src/Makefile /fd/mizar/src/
cp -avfu src/Make_com /fd/mizar/src/
cp -avfu src/Make_fil /fd/mizar/src/
cp -avfu src/Make_icp /fd/mizar/src/
cp -avfu src/Make_int /fd/mizar/src/
cp -avfu src/assisc.c /fd/mizar/src/
cp -avfu src/crinfo.c /fd/mizar/src/
cp -avfu src/curliv.c /fd/mizar/src/
cp -avfu src/genplt.c /fd/mizar/src/
cp -avfu src/genrle.c /fd/mizar/src/
cp -avfu src/grplot.c /fd/mizar/src/
cp -avfu src/istogr.c /fd/mizar/src/
cp -avfu src/mizcmn.c /fd/mizar/src/
cp -avfu src/numeri.c /fd/mizar/src/
cp -avfu src/stpdef.c /fd/mizar/src/
cp -avfu src/stpiot.c /fd/mizar/src/
cp -avfu src/stputl.c /fd/mizar/src/
cp -avfu src/string.c /fd/mizar/src/
cp -avfu src/utplot.c /fd/mizar/src/
cp -avfu src/icpcmn.c /fd/mizar/src/
cp -avfu src/mizint.c /fd/mizar/src/
cp -avfu src/pos.c    /fd/mizar/src/
cp -avfu src/tek.c    /fd/mizar/src/
cp -avfu src/tps.c    /fd/mizar/src/
cp -avfu src/ftn_f_interface.c /fd/mizar/src/
cp -avfu src/ftn_d_interface.c /fd/mizar/src/
cp -avfu src/inslib   /fd/mizar/src/
cp -avfu src/libicp   /fd/mizar/src/
cp -avfu src/bldicp   /fd/mizar/src/
cp -avfu src/icpcmn.h /fd/mizar/src/
cp -avfu src/mizcmn.h /fd/mizar/src/
cp -avfu src/mizlocdf.h /fd/mizar/src/
cp -avfu src/mizmsg.h /fd/mizar/src/
#
if [ ! -d /fd/mizar/test ]; then
	 mkdir /fd/mizar/test
fi
cp -avfu test/test.c        /fd/mizar/test/
cp -avfu test/test_curliv.c /fd/mizar/test/
cp -avfu test/test_funrea.c /fd/mizar/test/
cp -avfu test/tavola.c      /fd/mizar/test/
cp -avfu test/ist_1.c       /fd/mizar/test/
cp -avfu test/ist_2.c       /fd/mizar/test/
#
if [ ! -d /fd/mizar/util ]; then
	 mkdir /fd/mizar/util
fi
cp -avfu util/makefile   /fd/mizar/util/
cp -avfu util/lgbccr.h   /fd/mizar/util/
cp -avfu util/mizdat.c   /fd/mizar/util/
cp -avfu util/mizmsg.txt /fd/mizar/util/
#! end


