/*  <ftn_d_interface>
Sottoprogrammi di interfacciamento con il compilatore FORTRAN g77
Questo modulo dati provenienti da FORTRAN nel solo formato DOUBLE.
 */
#include <stdio.h>
#include <stdlib.h>
#include "mizar.h"
/*  */
VOID alfbet_(k)
     int *k;
{
  alfbet(*k);
  return;
}
/*  */
VOID angoli_(k)
     int *k;

{
  angoli(*k);
  return;
}
/*  */
VOID asse_(xin,yin,xfi,yfi,scin,scfi,lato,dim,testo,ntesto)
     DOUBLE *xin,*yin,*xfi,*yfi,*scin,*scfi;
     INT lato[];
     DOUBLE *dim;
     CHAR testo[];
     int *ntesto;
{
  asse(*xin,*yin,*xfi,*yfi,*scin,*scfi,lato,*dim,testo,*ntesto);
  return;
}
/*  */
VOID asslog_(xin,yin,xfi,yfi,scin,scfi,lato,dim,testo,ntesto)
     DOUBLE *xin,*yin,*xfi,*yfi,*scin,*scfi;
     INT lato[];
     DOUBLE *dim;
     CHAR testo[];
     int *ntesto;
{
asslog(*xin,*yin,*xfi,*yfi,*scin,*scfi,lato,*dim,testo,*ntesto);
  return;
}
/*  */
VOID coord_(k)
     int *k;
{
  coord(*k);
  return;
}
/*  */
VOID defcar_(ispo,ispv,ryx,dst)
     int *ispo,*ispv;
     DOUBLE *ryx,*dst;
{
  defcar(*ispo,*ispv,*ryx,*dst);
  return;
}
/*  */
VOID defcen_(gxcen,gycen)
     DOUBLE *gxcen,*gycen;
{
  defcen(*gxcen,*gycen);
  return;
}
/*  */
VOID deferr_(k,liv,mess,conta)
     int *k,*liv,*mess,*conta;
{
  deferr(*k,*liv,*mess,*conta);
  return;
}
/*  */
VOID deffat_(fat)
     DOUBLE *fat;
{
  deffat(*fat);
  return;
}
/*  */
VOID defftx_(fat)
     DOUBLE *fat;
{
  defftx(*fat);
  return;
}
/*  */
VOID deffty__(fat)
     DOUBLE *fat;
{
  deffty(*fat);
  return;
}
/*  */
VOID defgrl_(gxmin,gxmax,gymin,gymax)
     DOUBLE *gxmin,*gxmax,*gymin,*gymax;
{
  defgrl(*gxmin,*gxmax,*gymin,*gymax);
  return;
}
/*  */
VOID defpag_(gx,gy)
     DOUBLE *gx,*gy;
{
  defpag(*gx,*gy);
  return;
}
/*  */
VOID defpen_(kl,kf)
     int *kl,*kf;
{
  defpen(*kl,*kf);
  return;
}
/*  */
VOID defpun_(is,dim,rot)
     int *is;
     DOUBLE *dim,*rot;
{
  defpun(*is,*dim,*rot);
  return;
}
/*  */
VOID defris_(k)
     int *k;
{
  defris(*k);
  return;
}
/*  */
VOID defrot_(ang)
     DOUBLE *ang;
{
  defrot(*ang);
  return;
}
/*  */
VOID defsch_(fxmin,fxmax,
		    fymin,fymax)
     DOUBLE *fxmin,*fxmax,*fymin,*fymax;
{
  defsch(*fxmin,*fxmax,*fymin,*fymax);
  return;
}
/*  */
VOID defsim_(isim,dim,rot)
     int *isim;
     DOUBLE *dim,*rot;
{
  defsim(*isim,*dim,*rot);
  return;
}
/*  */
VOID errsta_(k)
     int *k;
{
  errsta(*k);
  return;
}
/*  */
VOID fine_()
{
  fine();
  return;
}
/*  */
VOID funrea_(f,xmin,xmax,iprec,modo,motr)
     DOUBLE (*f)();
     DOUBLE *xmin,*xmax;
     int *iprec,*modo;
     INT motr[];
{
  funrea(f,*xmin,*xmax,*iprec,*modo,motr);
  return;
}
/*  */
DOUBLE gmsgra_(igra,ipri,isec,icent)
     int *igra,*ipri,*isec,*icent;
{
  return(gmsgra(*igra,*ipri,*isec,*icent));
}
/*  */
DOUBLE gmsrad_(igra,ipri,isec,icent)
     int *igra,*ipri,*isec,*icent;
{
  return(gmsrad(*igra,*ipri,*isec,*icent));
}
/*  */
DOUBLE gradi_(rad)
     DOUBLE *rad;
{
  return(gradi(*rad));
}
/*  */
VOID gragms_(gra,igra,ipri,isec,icent)
     DOUBLE *gra;
     INT *igra,*ipri,*isec,*icent;
{
  gragms(*gra,igra,ipri,isec,icent);
  return;
}
/*  */
VOID grarea_(xmin,xmax,ymin,ymax)
     DOUBLE *xmin,*xmax,*ymin,*ymax;
{
  grarea(*xmin,*xmax,*ymin,*ymax);
  return;
}
/*  */
VOID utarea_(xmin,xmax,ymin,ymax)
     DOUBLE *xmin,*xmax,*ymin,*ymax;
{
  utarea(*xmin,*xmax,*ymin,*ymax);
  return;
}
/*  */
VOID grcer_(raggio,modo,motra)
     DOUBLE *raggio;
     int *modo;
     int motra[];
{
  grcer(*raggio,*modo,motra);
  return;
}
/*  */
VOID grcoor_(gx,gy,ipos)
     DOUBLE *gx,*gy;
     INT *ipos;
{
  double ggx,ggy;
  grcoor(&ggx,&ggy,ipos);
  *gx = ggx;
  *gy = ggy;
  return;
}
/*  */
VOID grcur_(gx,gy,car)
     DOUBLE *gx,*gy;
     CHAR *car;
{
  double ggx,ggy;
  grcur(&ggx,&ggy,car);
  *gx = ggx;
  *gy = ggy;
  return;
}
/*  */
VOID grmov_(x,y)
     DOUBLE *x,*y;
{
  grmov(*x,*y);
  return;
}
/*  */
VOID grseg_(x,y)
     DOUBLE *x,*y;
{
  grseg(*x,*y);
  return;
}
/*  */
VOID grpun_(x,y)
     DOUBLE *x,*y;
{
  grpun(*x,*y);
  return;
}
/*  */
VOID grsim_(x,y)
     DOUBLE *x,*y;
{
  grsim(*x,*y);
  return;
}
/*  */
VOID grtra_(x,y,motr)
     DOUBLE *x,*y;
     INT motr[];
{
  grtra(*x,*y,motr);
  return;
}
/*  */
VOID grmovr_(x,y)
     DOUBLE *x,*y;
{
  grmovr(*x,*y);
  return;
}
/*  */
VOID grsegr_(x,y)
     DOUBLE *x,*y;
{
  grsegr(*x,*y);
  return;
}
/*  */
VOID grpunr_(x,y)
     DOUBLE *x,*y;
{
  grpunr(*x,*y);
  return;
}
/*  */
VOID grsimr_(x,y)
     DOUBLE *x,*y;
{
  grsimr(*x,*y);
  return;
}
/*  */
VOID grtrar_(x,y,motr)
     DOUBLE *x,*y;
     INT motr[];
{
  grtrar(*x,*y,motr);
  return;
}
/*  */
VOID utcer_(raggio,modo,motra)
     DOUBLE *raggio;
     int *modo;
     int motra[];
{
  utcer(*raggio,*modo,motra);
  return;
}
/*  */
VOID utcoor_(gx,gy,ipos)
     DOUBLE *gx,*gy;
     INT *ipos;
{
  double ggx,ggy;
  utcoor(&ggx,&ggy,ipos);
  *gx = ggx;
  *gy = ggy;
  return;
}
/*  */
VOID utcur_(gx,gy,car)
     DOUBLE *gx,*gy;
     CHAR *car;
{
  double ggx,ggy;
  utcur(&ggx,&ggy,car);
  *gx = ggx;
  *gy = ggy;
  return;
}
/*  */
VOID utmov_(x,y)
     DOUBLE *x,*y;
{
  utmov(*x,*y);
  return;
}
/*  */
VOID utseg_(x,y)
     DOUBLE *x,*y;
{
  utseg(*x,*y);
  return;
}
/*  */
VOID utpun_(x,y)
     DOUBLE *x,*y;
{
  utpun(*x,*y);
  return;
}
/*  */
VOID utsim_(x,y)
     DOUBLE *x,*y;
{
  utsim(*x,*y);
  return;
}
/*  */
VOID uttra_(x,y,motr)
     DOUBLE *x,*y;
     INT motr[];
{
  uttra(*x,*y,motr);
  return;
}
/*  */
VOID utmovr_(x,y)
     DOUBLE *x,*y;
{
  utmovr(*x,*y);
  return;
}
/*  */
VOID utsegr_(x,y)
     DOUBLE*x,*y;
{
  grsegr(*x,*y);
  return;
}
/*  */
VOID utpunr_(x,y)
     DOUBLE *x,*y;
{
  utpunr(*x,*y);
  return;
}
/*  */
VOID utsimr_(x,y)
     DOUBLE *x,*y;
{
  utsimr(*x,*y);
  return;
}
/*  */
VOID uttrar_(x,y,motr)
     DOUBLE *x,*y;
     INT motr[];
{
  uttrar(*x,*y,motr);
  return;
}
/*  */
VOID inizio_(k)
     FILE *k;
{
  inizio(0);
  return;
}
/*  */
VOID numerr_(k)
     int *k;
{
  numerr(*k);
  return;
}
/*  */
VOID numesp_(gx,gy,ipos,ibase,iesp,dim,rot,ncar)
     DOUBLE *gx,*gy;
     int *ipos,*ibase,*iesp;
     DOUBLE *dim,*rot;
     INT *ncar;
{
  numesp(*gx,*gy,*ipos,*ibase,*iesp,*dim,*rot,ncar);
  return;
}
/*  */
VOID numint_(gx,gy,ipos,num,dim, rot,ncar)
     DOUBLE *gx,*gy;
     int *ipos;
     long *num;
     DOUBLE  *dim,*rot;
     INT *ncar;
{
  numint(*gx,*gy,*ipos,*num,*dim,*rot,ncar);
  return;
}
/*  */
VOID numrea_(gx,gy,ipos,num,ndec,dim,rot,ncar)
     DOUBLE *gx,*gy;
     int *ipos;
     DOUBLE *num;
     int *ndec;
     DOUBLE *dim,*rot;
     INT *ncar;
{
  numrea(*gx,*gy,*ipos,*num,*ndec,*dim,*rot,ncar);
  return;
}
/*  */
VOID pagina_()
{
  pagina();
  return;
}
/*  */
VOID paglim_(gx,gy)
     DOUBLE *gx,*gy;
{
  double ggx,ggy;
  paglim(&ggx,&ggy);
  *gx = ggx;
  *gy = ggy;
  return;
}
/*  */
VOID penna_(k)
     int *k;
{
  penna(*k);
  return;
}
/*  */
VOID quadro_(assex,nx,assey,ny)
     char *assex,*assey;
     int *nx,*ny;
{
  quadro(assex,*nx,assey,*ny);
  return;
}
/*  */
VOID quadre_(assex,nx,assey,ny)
     char *assex,*assey;
     int *nx,*ny;
{
  quadre(assex,*nx,assey,*ny);
  return;
}
/*  */
VOID radgms_(rad,igra,ipri,isec,icent)
     DOUBLE *rad;
     INT *igra,*ipri,*isec,*icent;
{
  radgms(*rad,igra,ipri,isec,icent);
  return;
}
/*  */
DOUBLE radian_(gra)
     DOUBLE *gra;
{
  return(radian(*gra));
}
/*  */
VOID schlim_(gxmin,gxmax,gymin,gymax)
     DOUBLE *gxmin,*gxmax,*gymin,*gymax;
{
  double xmin,xmax,ymin,ymax;
  schlim(&xmin,&xmax,&ymin,&ymax);
  *gxmin = xmin;
  *gxmax = xmax;
  *gymin = ymin;
  *gymax = ymax;
  return;
}
/*  */
INT stralf_(istr,ncar,dim,rot)
     CHAR istr[];
     int *ncar;
     DOUBLE *dim,*rot;
{
  return(stralf(istr,*ncar,*dim,*rot));
}
/*  */
VOID svuota_()
{
  return;
}
/*  */
VOID lgfmm_(vet,nv,rmin,rmax)
     DOUBLE vet[];
     int *nv;
     DOUBLE *rmin,*rmax;
{
  lgfmm(vet,*nv,rmin,rmax);
  return;
}
/* NOTA: Il sottoprogramma curliv non fa parte della versione stabile
         di MiZaR.  In particolare, il sottoprogramma di
         interfacciamento qui sotto *non* e' stato sottoposto a test.
   NOTA TECNICA:
         Le convenzioni FORTRAN e C per l'allineamento dei dati in matrice 
         sono incompatibili.  Per questo motivo il sottoprogramma qui sotto
	 alloca una matrice della stessa dimensione di quella fornita in 
	 ingresso, e vi copia il contenuto della matrice in ingresso 
	 modificando l'ordinamento dei dati in modo compatibile con le 
	 convenzioni del compilatore C.  La memoria allocata viene liberata 
	 prima del rientro.
	 Tuttavia non si esclude che , in condizioni critiche di memoria, si 
	 possa verificare un errore di allocazione.
*/
INT curliv_(fmat,nx,ny,fliv,fcr)
     int *nx;
     int *ny;
     DOUBLE fmat[];
     DOUBLE *fliv;
     DOUBLE *fcr;
{
  long int j,m,kx,ky,size;
  DOUBLE *tmpmat;
				/* Trasposizione della matrice;
                                   necessaria perche' la convenzione
                                   per l'ordinamento dei dati in
                                   matrice in FORTRAN e' diversa dalla
                                   convenzione C 
				*/
  size = ((long int) *nx) * ((long int) *ny) * sizeof(double);
  if((tmpmat = malloc(size)) == NULL) {
    printf("curliv: errore nell'allocazione della matrice trasposta.\n");
    return(-1);
  }
  for(m=0,kx=0;kx<(*nx);kx++){
    j=kx;
    for(ky=0;ky<(*ny);ky++) {
      tmpmat[j]=fmat[m++];
      j+=(*nx);
    }
  }
  curliv(tmpmat,*ny,*nx,*fliv,*fcr);
  free(tmpmat);
  return;
}
