/* Definizioni comuni */
#define MIZAR_PCVERSION 0
#define MIZAR_LinuxVERSION 1
#if MIZAR_PCVERSION
typedef char __far CHAR;
typedef unsigned char __far UNSCHAR;
typedef int INT;
typedef long int __far LONG;
typedef unsigned int __far UNSINT;
typedef float __far FLOAT;
typedef double __far DOUBLE;
typedef void __far VOID;
#endif
#if MIZAR_LinuxVERSION
typedef char CHAR;
typedef unsigned char UNSCHAR;
typedef int INT;
typedef long int LONG;
typedef unsigned int UNSINT;
typedef float FLOAT;
typedef double DOUBLE;
typedef void VOID;
#endif
/* icp */
extern  CHAR lgcur(DOUBLE *fx,DOUBLE *fy);
extern  CHAR lgzoom(DOUBLE *fx0,DOUBLE *fy0,
		    DOUBLE *fx1,DOUBLE *fy1);
extern  VOID lgpag(int kpg);
extern  VOID lgmov(double fx,double fy);
extern  VOID lgpen(int k);
extern  VOID lgsvuo();
/* genrle */
#if MIZAR_PCVERSION
extern  VOID lgwmsg(int nmsg,...);
extern  VOID lgerr(int nmsg,...);
#endif
#if MIZAR_LinuxVERSION
extern  VOID lgwmsg();
extern  VOID lgerr();
#endif
extern  VOID lgwbuf(void );
extern  VOID lgbuff(UNSCHAR ibuf[],int n,int modo);
extern  VOID lgcmdo(int j,UNSCHAR l[],int nl);
extern  VOID lgcmpt(DOUBLE x[],int k);
extern  VOID lgwepg(void );
extern  VOID lgwmtr(void );
extern  VOID lgwsmc(void );
extern  VOID lgwpen(void );
extern  VOID lgwdrs(void );
extern  VOID lgwtbo(void );
extern  VOID lgwtbv(void );
extern  VOID lgwcar(void );
extern  VOID lgwmrg(void );
extern  CHAR lgspag(void );
extern  INT inizio(FILE *k);
extern  VOID lginit(void );
extern  VOID lgit2c(int k,UNSCHAR cb[]);
extern  VOID lgli4c(long k,UNSCHAR cb[]);
extern  VOID lgfine(int k);
extern  VOID pagina(void );
extern  VOID fine(void );
extern  INT defpag(double gx,double gy);
extern  VOID defgrl(double gxmin,double gxmax,
		    double gymin,double gymax);
extern  VOID errsta(int k);
/* genplt */
extern VOID lgpfcv(void );
extern VOID lgcvgf(double gx,double gy,DOUBLE *fx,DOUBLE *fy);
extern VOID lgcvfg(double fx,double fy,DOUBLE *gx,DOUBLE *gy);
extern VOID lgplof(double gx,double gy);
extern VOID lgsim(char k);
extern VOID lgploi(int k);
extern INT lgpos(DOUBLE x[],int n,DOUBLE xlim[]);
extern VOID lgimpc(double gx,double gy);
extern VOID lgzac(DOUBLE x1[],DOUBLE x2[],DOUBLE xlim[],INT *k1,
   		INT *k2,UNSCHAR *kout,int n);
extern VOID lgagrn(char k);
extern VOID lgcvcp(double cx,double cy,DOUBLE *rag,DOUBLE *ang);
extern INT lgprcv(void );
extern INT lgcvug(double x,double y,DOUBLE *gx,DOUBLE *gy);
extern VOID lgcvgu(double gx,double gy,DOUBLE *x,DOUBLE *y);
extern INT lgplot(double x,double y,int modo);
extern INT lgplo1(int modo);
/* grplot */
extern INT grarea(double xgmin,double xgmax,
		  double ygmin,double ygmax);
extern INT grmov(double gx,double gy);
extern INT grseg(double gx,double gy);
extern INT grpun(double gx,double gy);
extern INT grsim(double gx,double gy);
extern INT grtrt(double gx,double gy);
extern INT grtra(double gx,double gy,INT motr[]);
extern INT grmovr(double gx,double gy);
extern INT grsegr(double gx,double gy);
extern INT grpunr(double gx,double gy);
extern INT grsimr(double gx,double gy);
extern INT grtrtr(double gx,double gy);
extern INT grtrar(double gx,double gy,INT motr[]);
extern INT deftrt(INT modo[]);
/* utplot */
extern  INT utarea(double xmin,double xmax,
		   double ymin,double ymax);
extern  INT utmov(double x,double y);
extern  INT utseg(double x,double y);
extern  INT utpun(double x,double y);
extern  INT utsim(double x,double y);
extern  INT uttrt(double x,double y);
extern  INT uttra(double x,double y,INT modo[]);
extern  INT utmovr(double x,double y);
extern  INT utsegr(double x,double y);
extern  INT utpunr(double x,double y);
extern  INT utsimr(double x,double y);
extern  INT uttrtr(double x,double y);
extern  INT uttrar(double x,double y,INT modo[]);
/* string */
extern  INT defdrs(double dim,double rot);
extern  VOID lgcntr(void );
extern  INT stralf(CHAR istr[],int ncar,double dim,double rot);
/* numeri */
extern  DOUBLE lgpow10(int k);
extern  INT lgcint(long ival,char *buf,int nbuf);
extern  INT lgcrea(double rnum,int ndec,char *buf,int nbuf);
extern  INT lgcreb(double rval,char *buf,int nbuf,int ncmin);
extern  INT lgcrex(double rnum,int ndec,char *buf,int nbuf);
extern  INT numrea(double gx,double gy,int ipos,double rnum,
		   int ndec,double dim,double rot,INT *ncar);
extern  INT numint(double gx,double gy,int ipos,long num,
		   double dim,double rot,INT *ncar);
extern  INT numesp(double gx,double gy,int ipos,int ibase,
		   int iesp,double dim,double rot,INT *ncar);
extern  INT lgwnum(double gx,double gy,char *iffc,int kc,
		   int ipos,double dim,double rot);
/* assisc */
extern  VOID lgtrlg(void );
extern  VOID lgsclg(CHAR testo[],int ntesto);
extern  VOID lgwlab(double gx,double gy,double dgx,double dgy,
		    int j,int kp,CHAR testo[],int ntesto);
extern  VOID lgtras(void );
extern  VOID lgscal(CHAR testo[],int ntesto);
extern  VOID lgprsl(void );
extern  VOID lgprsc(void );
extern  VOID lgaslg(CHAR testo[],int ntesto);
extern  VOID lgasli(CHAR testo[],int ntesto);
extern  VOID quadro(CHAR testx[],int ntestx,
		    CHAR testy[],int ntesty);
extern  VOID quadre(CHAR testx[],int ntestx,
		    CHAR testy[],int ntesty);
extern  VOID asslog(double xin,double yin,double xfi,double yfi,
		    double scin,double scfi,INT lato[],
		    double dim,CHAR testo[],int ntesto);
extern  VOID asse(double xin,double yin,double xfi,double yfi,
		  double scin,double scfi,INT lato[],
		  double dim,CHAR testo[],int ntesto);
/* stpdef */
extern  VOID angoli(int k);
extern  VOID coord(int k);
extern  VOID penna(int k);
extern  VOID defbat(int k);
extern  VOID defcar(int ispo,int ispv,double ryx,double dst);
extern  VOID defcen(double gxcen,double gycen);
extern  VOID deffat(double fat);
extern  VOID defftx(double fat);
extern  VOID deffty(double fat);
extern  VOID defmar(double exmin,double exmax,
		    double eymin,double eymax);
extern  VOID defsim(int isim,double dim,double rot);
extern  VOID deftbo(DOUBLE tab[],int n);
extern  VOID deftbv(DOUBLE tab[],int n);
extern  VOID defpen(int kl,int kf);
extern  VOID defpns(int kl);
extern  VOID defpun(int is,double dim,double rot);
extern  VOID defris(int k);
extern  VOID defrot(double ang);
extern  VOID defsch(double fxmin,double fxmax,
		    double fymin,double fymax);
extern  VOID deferr(int k,int liv,int mess,int conta);
/* crinfo */
extern  VOID grcoor(DOUBLE *gx,DOUBLE *gy,INT *ipos);
extern  VOID utcoor(DOUBLE *x,DOUBLE *y,INT *ipos);
extern  VOID grcur(DOUBLE *gx,DOUBLE *gy,CHAR *car);
extern  VOID grzoom(DOUBLE *gx0,DOUBLE *gy0,
		    DOUBLE *gx1,DOUBLE *gy1,CHAR *car);
extern  VOID utcur(DOUBLE *x,DOUBLE *y,CHAR *car);
extern  VOID utzoom(DOUBLE *x0,DOUBLE *y0,
		    DOUBLE *x1,DOUBLE *y1,CHAR *car);
extern  VOID schlim(DOUBLE *fxmin,DOUBLE *fxmax,
		    DOUBLE *fymin,DOUBLE *fymax);
extern  INT numerr(int k);
extern  INT ulterr(void );
/* stputl */
extern  VOID retpag(void );
extern  VOID paglim(DOUBLE *gx,DOUBLE *gy);
extern  VOID alfbet(int k);
extern  DOUBLE gmsgra(int igra,int ipri,int isec,int icent);
extern  DOUBLE gmsrad(int igra,int ipri,int isec,int icent);
extern  DOUBLE gradi(double rad);
extern  VOID gragms(double gra,INT *igra,
		    INT *ipri,INT *isec,INT *icent);
extern  VOID radgms(double rad,
		    INT *igra,INT *ipri,INT *isec,INT *icent);
extern  DOUBLE radian(double gra);
extern  VOID grcer(double raggio,int modo,INT motra[]);
extern  VOID utcer(double raggio,int modo,INT motra[]);
extern  INT lgclrb(UNSCHAR k[],long nbit);
extern  INT lgsetb(UNSCHAR k[],long nbit);
extern  INT lgstab(UNSCHAR k[],long nbit);
extern  VOID lgfmin(DOUBLE vet[],long nv,DOUBLE *rmin);
extern  VOID lgfmax(DOUBLE vet[],long nv,DOUBLE *rmax);
extern  VOID lgfmm(DOUBLE vet[],long nv,DOUBLE *rmin,DOUBLE *rmax);
extern  VOID lgfmed(DOUBLE x[],long n,DOUBLE *rmed);
extern  VOID lgfsum(DOUBLE x[],long n,DOUBLE *sum);
extern  VOID funrea(DOUBLE (*f)(),double xmin,double xmax,
		    int iprec,int modo,INT motr[]);
extern  VOID lginv(DOUBLE x[],DOUBLE y[],int n);
extern  VOID utlin(DOUBLE x[],DOUBLE y[], LONG n, INT modo, INT motra[]);
extern  int lgarrestr(DOUBLE xinf, DOUBLE xsup, DOUBLE *xmen, DOUBLE *xpiu);
extern  VOID ut_graf_scala(DOUBLE *x, DOUBLE *y, int ndati, int karea);
/* stpiot */
extern  INT lgdint(CHAR buf[],int kin,int kfi,INT *i);
extern  INT lgdlng(CHAR buf[],int kin,int kfi,LONG *i);
extern  INT lgdrea(CHAR buf[],int kin,int kfi,FLOAT *rea);
extern  INT lgddbl(CHAR buf[],int kin,int kfi,DOUBLE *dbl);
extern  INT lgddbb(CHAR buf[],int kin,int kfi,DOUBLE *d);
extern  INT lgelbl(CHAR buf[],int n);
extern  INT lgrdst(CHAR buf[],int nb,CHAR *ctrm);
extern  INT lgrdne(CHAR buf[],int nb,CHAR *ctrm);
extern  INT lgldln(CHAR prompt[],LONG *lval);
extern  INT lgldin(CHAR prompt[],INT *ival);
extern  INT lglddb(CHAR prompt[],DOUBLE *val);
extern  INT lgldre(CHAR prompt[],FLOAT *val);
extern int linux_getch();
extern  VOID lgclrs(void );
/* livell */
extern VOID livell(double *fmat,int nx,int ny,int modot,
                   int *motra,int modol,double fcr,double *av,
      	           int ilbls,int numcif,double dimch,double sepch);
extern VOID lgcur0(double *fmat,int nx,int ny,int nliv,int modol);
extern VOID lgcur1(double *fmat,int nx,int ny);
extern VOID lgcur2(double *fmat,int nx,int ny);
/* istogr */
extern int istogr(DOUBLE dati[],LONG ndati,DOUBLE rdint[],INT nint,
		   int imodo,LONG *itot,LONG *ibuoni,
		   DOUBLE xmin,DOUBLE xmax,DOUBLE ymin,DOUBLE ymax,
		   char *testx,int ntestx,char *testy,int ntesty);
/* curliv */
extern VOID curliv(DOUBLE fmat[], int nx,int ny,DOUBLE fliv,DOUBLE fcr);
extern VOID clvmin(DOUBLE fmat[], int nx,int ny);
extern VOID colora_mappa(DOUBLE fmat[],int nx,int ny,DOUBLE zmin,DOUBLE zmax,int jpenmin,int jpenmax);
/* getutl */
extern VOID getutlim(DOUBLE *xmin,  DOUBLE *xmax, DOUBLE *ymin, DOUBLE *ymax);
