#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mizar.h"

#define NINTV 850
#define NDATI 1000000

double Xvet[NDATI];
double Rint[NINTV];

int main()
{
  long double sum;
  double xmin, xmax, smed;
  LONG j, itot, ibuoni;
  for(j=0; j<NDATI; j++) 
    sum += (Xvet[j] = drand48());
  sum /= ((long double) NDATI);
  printf("media: %le", (double) sum);
  inizio(0);
  defpag(1023., 767.);
  grarea(100., 950., 100., 700.);
  xmin = 0.;  xmax = 1.;
  istogr(Xvet, NDATI, Rint, NINTV, 256,
	   &itot,&ibuoni,xmin,xmax,0.,0.,
	 "x",1,"Distribuzione",13);
  fine();
  return(0);
}
