#include <stdio.h>
#include <math.h>
#include "mizar.h"
#define MARG      8.
#define VSPACE    10.
#define DIMTITLE  2.5
#define HTITLE   (16.*DIMTITLE+2.*VSPACE)
#define DIMTS     1.5
#define HTITSEZ  (32.*DIMTS+2.*VSPACE)
#define VSIM      5.
#define DIMSIM    1.5
#define HSIMB    (16.*DIMSIM+VSIM)
#define WCOL     (64.*DIMTS)
#define WSEZ     (WCOL+WCOL+MARG)
#define PX (8*WSEZ+MARG+1.)
#define PY (2.*MARG+HTITLE+HTITSEZ+32.*HSIMB+4.*VSPACE+2.)
#define STRTIT "T A V O L A   D E I   C A R A T T E R I   S O F T W A R E"
#define STRSIM "Simbolo"
#define STRCOD1 "Codice"
#define STRCOD2 "ottale"
#define PENLIN 1
#define PENSIM 2
				/*  */
int main()
{
  double gxs,gxv,gys,gx,gy,gy0,sx,sy;
  int j,k,k0,ks;
  char buf[8];
  inizio(0);
  defpag(PX+1.,PY+1.);
  penna(PENLIN); 
  grmov(1.,1.);  
  grseg(1.,PY);  grseg(PX-1.,PY);  
  grseg(PX,1.);  grseg(1.,1.);
  grmov(MARG,MARG);  
  grseg(MARG,PY-MARG);  grseg(PX-MARG,PY-MARG);  
  grseg(PX-MARG,MARG);  grseg(MARG,MARG);
			/* "Tavola dei caratteri software" */
  penna(PENSIM);
  sy=PY-MARG-VSPACE-16.*DIMTITLE;
  j=strlen(STRTIT);
  sx=.5*(PX-8.*DIMTITLE*j);
  grmov(sx,sy);  penna(2);  stralf(STRTIT,j,DIMTITLE,0.);  penna(1);
  gy0=PY-MARG-HTITLE-VSPACE;
  penna(PENLIN); 
  grmov(MARG,gy0);  grseg(PX-MARG,gy0);
  grmov(PX-MARG,gy0-HTITSEZ);  grseg(MARG,gy0-HTITSEZ);
				/* Colonne dei simboli */
  gx=MARG;  k0=1;
  for(j=0;j<8;j++) {
				/* "Simbolo" */
    penna(PENSIM);
    k=strlen(STRSIM);   gxs=gx+.5*(WCOL-8.*DIMTS*k);  gys=gy0-.5*(HTITSEZ+16.*DIMTS);
    grmov(gxs,gys);  stralf(STRSIM,k,DIMTS,0.);
    penna(PENLIN);
    grmov(gx+WCOL,gy0); grseg(gx+WCOL,MARG);
				/* "Codice ottale" */
    penna(PENSIM);
    k=strlen(STRCOD1);  gxs=gx+WCOL+.5*(WCOL-8.*DIMTS*k);  gys=gy0-.5*HTITSEZ;
    grmov(gxs,gys);  stralf(STRCOD1,k,DIMTS,0.);
    gys-=16.*DIMTS;  
    grmov(gxs,gys);  stralf(STRCOD2,k,DIMTS,0.);
    penna(PENLIN);
    grmov(gx+2.*WCOL,gy0);  grseg(gx+2.*WCOL,MARG);
    grmov(gx+WSEZ,MARG);    grseg(gx+WSEZ,gy0);
				/*  */
    gxs=gx+.5*(WCOL-8.*DIMSIM);
    gxv=gx+WCOL+.5*(WCOL-24.*DIMSIM);
    gys=gy0-HTITSEZ-VSPACE-HSIMB;
    penna(PENSIM);
    for(k=0;k<32;k++) {
      if((ks=k+k0)>255) continue;
      if(ks<32) {
	defsim(ks,DIMSIM,0.);
	grsim(gxs+5.,gys+3.);
      }
      else {
	grmov(gxs,gys);
	buf[0]=ks;  buf[1]='\000';  stralf(buf,1,DIMSIM,0.);
      }
      sprintf(buf,"%03o",ks);
      grmov(gxv,gys);
      stralf(buf,3,DIMSIM,0.);
      gys-=HSIMB;
    }
    k0+=32;
    gx+=WSEZ;
  }
  fine();
  exit(0);
}
