\scheda{alfbet}
\tipo{S}

\scopo
Fissa l'$\,$alfabeto in uso. La modifica di alfabeto
viene applicata a tutti i caratteri trattati mediante i
sottoprogrammi di gestione di stringhe alfanumeriche,
compatibilmente con le limitazioni specificate sotto.

\ccall
alfbet(k)
int k;
\endccall

\param
\prm{k}Variabile o costante intera che
specifica l'$\,$alfabeto da usare. Pu\`o assumere i
valori:
\paritm{1}alfabeto latino;
\paritm{2}alfabeto greco;
\paritm{3}alfabeto speciale.

\limit
Vengono modificati solo i caratteri con codice ottale compreso
tra 100 e 177 (64 e 127 decimale), mentre tutti gli altri restano invariati.
Questo permette di utilizzare per l'$\,$input il solo insieme di caratteri
alfanumerici presenti su tutti i terminali.

\conderr
\errit{LGE\_ALFABETO}Il valore specificato in {\tt k} non \`e uno di
quelli previsti: l'$\,$alfabeto richiesto non esiste.

