\scheda{asslog}
\tipo{S}
\scopo
Traccia un asse con scala logaritmica, aggiungendo a richiesta la
scala e un'$\,$etichetta.

\ccall
asslog(xin,yin,xfi,yfi,scin,scfi,
\spz lato,dim,testo,ntesto);
float xin,xfi,yin,yfi,scin,scfi;
int lato[2];
float dim;
char testo[];
int ntesto;
\endccall

\val 
Nessuno.

\param
\prm{xin,yin}Variabili o costanti reali contenenti le
coordinate utente dell'$\,$estremo iniziale dell'$\,$asse.
\prm{xfi,yfi}Variabili o costanti reali contenenti le
coordinate utente dell'$\,$estremo finale dell'$\,$asse.
\prm{scin}Variabile o costante reale contenente il
valore della scala corrispondente all'$\,$estremo
iniziale dell'$\,$asse.
\prm{scfi}Variabile o costante reale contenente il
valore della scala corrispondente all'$\,$estremo
finale dell'$\,$asse.
\prm{lato}Vettore di due interi che contiene le specifiche per
il tracciamento dei tratti di suddivisione e della scala.
Il primo elemento di {\tt lato} specifica il modo 
di tracciare i tratti di suddivisione. Pu\`o
assumere i valori:
\paritm{-1 :}tratti a sinistra rispetto alla
direzione di tracciamento dell'$\,$asse (da {\tt xin,yin} a {\tt 
xfi,yfi});
\paritm{0\ :}tratti centrati rispetto all'$\,$asse;
\paritm{1\ :}tratti a destra rispetto all'$\,$asse.
\prm{}Il secondo elemento di {\tt lato} specifica la 
modalit\`a di scrittura della scala. Pu\`o assumere i valori:
\paritm{-2\ :}scala scritta a sinistra dell'$\,$asse,
perpendicolarmente alla direzione dell'$\,$asse stesso;
\paritm{-1\ :}scala a sinistra, parallela all'$\,$asse;
\paritm{0\ :}per omettere la scrittura della scala;
\paritm{1\ :}scala a destra, parallela all'$\,$asse;
\paritm{2\ :}scala a destra, perpendicolare all'$\,$asse.
\prm{dim}Variabile o costante reale contenente la
dimensione della scala e delle scritte. 
\prm{testo}Stringa di caratteri che viene riportata come etichetta
dell'$\,$asse, parallelamente ad esso e dallo stesso lato della scala.
\prm{ntesto}Variabile o costante intera contenente il
numero di caratteri della stringa {\tt testo}. 
Se {\tt ntesto} \`e negativo o nullo si intende che la scritta deve essere
omessa.

\limit
Gli estremi dell'$\,$asse e della scala non devono essere coincidenti, e
quelli della scala devono essere positivi.
\`E ammesso tuttavia che il secondo estremo della scala sia inferiore
al primo.

La dimensione dei caratteri devone rispettare le limitazioni esposte
nella descrizione del sottoprogramma {\tt defdrs}. Inoltre per la
stringa {\tt testo} valgono tutte le note riportate nella scheda del
sottoprogramma {\tt stralf}.

\conderr
\errit{LGE\_DIMCARATT}La dimensione dei caratteri non \`e corretta.
\errit{LGE\_ESTRASSE}Sono stati specificati estremi coincidenti.
\errit{LGE\_ESTRSCALA}Gli estremi specificati per la scala sono coincidenti.
\errit{LGE\_ESTRLOGNEG}Gli estremi della scala non sono entrambi 
positivi.
\errit{LGE\_SCALA}Il vettore {\tt lato} contiene valori non previsti.
