\scheda{defftx}
\tipo{S}
\scopo
{\corsivo Interattiva:\quad}Definisce un fattore di scala da applicare
all'$\,$asse x prima del tracciamento. Pu\`o essere usato per produrre
copie di diverse dimensioni, senza rispetto delle proporzioni.
\par\noindent
{\corsivo File grafico:\quad}La chiamata non ha alcun effetto sul file grafico.

\ccall
defftx(fat)
float fat;
\endccall

\param
\prm{fat}Variabile o costante reale contenente il fattore di scala
\valdef
Non viene applicato nessun fattore di scala ({\tt fat}=1.).
\limit
Il valore specificato in {\tt fat} deve essere positivo.
\conderr
\errit{LGE\_FATTSCALA}\`E stato specificato un fattore di scala
negativo o nullo.

\note
Il fattore di scala viene applicato compatibilmente con la necessit\`a
di riscalare il disegno se questo supera i limiti dell'$\,$area
fisicamente disponibile. L'$\,$applicazione viene effettuata
correttamente se il riscalamento automatico \`e stato disabilitato
mediante il sottoprogramma {\tt defris},
\ina{Sottoprogramma DEFRIS}
\ina{Riscalamento}
ma in questo caso eventuali parti non contenute nell'$\,$area fisica
vengono tagliate. \par Il riscalamento del disegno \`e controllato dai
sottoprogrammi {\tt deffat}, {\tt defftx}, {\tt deffty}.
\ina{Sottoprogramma>deffat}
\ina{Sottoprogramma>defftx}
\ina{Sottoprogramma>deffty}
Se questi vengono richiamati pi\'u volte resta in uso il fattore
definito per ultimo.

