\scheda{defsch}
\tipo{S}

\scopo
Definisce i limiti fisici dell'$\,$area di schermo da utilizzare per il
tracciamento del disegno.
\ccall
defsch(fxmin,fxmax,fymin,fymax)
float fxmin,fxmax,fymin,fymax;
\endccall

\param
\prm{fxmin}
\prm{fxmax}
\prm{fymin}
\prm{fymax}Variabili o costanti reali contenenti le coordinate, in
unit\`a fisiche, degli estremi dell'$\,$area.
\valdef
Vengono assunti i valori specificati nella guida relativa al periferico
in uso.
\limit
I valori devono rispettare le limitazioni
$$
0\le {\tt fxmin} < {\tt fxmax}
\ ,\quad
0\le {\tt fymin} < {\tt fymax}
$$
e non superare il massimo consentito per il periferico in uso.
\conderr
\errit{LGE\_AREAFISICA}I limiti specificati non rispettano le
condizioni imposte.

