\scheda{deftrt}
\tipo{S}
\scopo
Specifica la modalit\`a di tratteggio da usare in tutte le chiamate 
successive.

\ccall
int deftrt(modo);
int modo[];
\endccall

\val
In caso di esecuzione corretta viene restituito zero; in caso di errore viene 
restituito uno dei codici riportati sotto. 

\param
\prm{modo}Vettore di al pi\'u 11 elementi che contiene la specifica
della modalit\`a di tratteggio. Il valore assoluto di ogni
elemento del vettore specifica la
lunghezza del tratto di cui si deve spostare la penna;
il segno specifica se lo spostamento deve avvenire a penna alzata (segno -)
o abbassata (segno +); l'$\,$ultimo elemento utile di {\tt modo} deve essere 0.
Ad esempio, la successione (5, -5, 20, -20, 0) significa :
\paritm{i.}trattino di 5 unit\`a grafiche;
\paritm{ii.}movimento di 5 unit\`a grafiche;
\paritm{iii.}trattino di 20 unit\`a grafiche;
\paritm{iv.}movimento di 20 unit\`a grafiche;
\paritm{v.}riprendi da i.

\valdef
Il vettore contiene i valori 10,-10,0.

\limit
Il vettore {\tt modo} non deve contenere pi\'u di 11 elementi (10 utili pi\'u
lo 0 finale). In ogni caso vengono ignorati gli elementi oltre il decimo.
\par
Il singolo spostamento definito dal vettore {\tt modo} non deve superare 127
unit\`a grafiche. In ogni caso ne viene calcolato il modulo rispetto a 
128, senza segnalazione in caso di errore.

\conderr
\errit{LGE\_TRATTEGGIO}Il vettore {\tt modo} contiene pi\'u di 10
elementi non nulli.

