\scheda{grarea}
\tipo{S}
\scopo
Definisce gli estremi dell'$\,$area grafica, in unit\`a grafiche.

\ccall
int grarea(gxmin,gxmax,gymin,gymax);
float gxmin,gxmax,gymin,gymax;
\endccall

\val
In caso di esecuzione corretta viene restituito zero; in caso di errore viene 
restituito uno dei codici riportati sotto. 

\param
\prm{gxmin}
\prm{gxmax}Variabili o costanti reali contenenti gli estremi delle
coordinate, in unit\`a grafiche, lungo l'$\,$asse $x$.
\prm{gymin}
\prm{gymax}Variabili o costanti reali contenenti gli estremi delle
coordinate, in unit\`a grafiche, lungo l'$\,$asse $y$.

\valdef
L'$\,$area grafica coincide con la pagina.

\limit
Devono essere verificate le condizioni ${\tt gxmin}<{\tt gxmax}$, ${\tt 
gymin}<{\tt gymax}$.
Inoltre il rettangolo definito da questi estremi deve
essere contenuto nella pagina.

\conderr
\errit{LGE\_AREAGRAF}L'$\,$area definita non \`e contenuta nella pagina.
\errit{LGE\_ESTREMIARGR}Non sono rispettate le condizioni di ordinamento sugli
estremi dell'$\,$area grafica.

\note
Eventuali ridefinizioni della pagina mediante il sottoprogramma {\tt
defpag}\ina{Sottoprogramma>defpag} annullano l'$\,$effetto della
chiamata, in quanto fanno coincidere l'$\,$area grafica con la pagina
stessa. Pu\`o quindi essere necessario chiamare nuovamente il
sottoprogramma dopo aver ridefinito la pagina.
