\scheda{pagina} 

\tipo{S} \scopo 
{\corsivo Interattiva:\quad}Chiude una
pagina di disegno completando le operazioni di tracciamento.  Poi
suona il cicalino del terminale, ed attende che venga battuto un
carattere $\langle{\tt return}\rangle$.  Infine cancella lo schermo e
compie tutte le azioni necessarie per aprire la pagina successiva.

\vskip 3pt
\noindent{\corsivo File grafico:\quad}Chiude una pagina di
disegno e ne inizia una nuova.  

\vskip 3pt \noindent {\corsivo Completa:\quad}Come per la versione
interattiva, chiede autorizzazione prima di iniziare una nuova pagina.
L'$\,$azione sul file grafico dipende dalla risposta: se viene battuto
un carattere `{\tt c}' o `{\tt C}' (cancella) oppure `{\tt n}' o `{\tt
N}' (no) seguito da $\langle{\tt return}\rangle$ la pagina corrente
viene eliminata dal file grafico; qualunque altro carattere, o
semplicemente il tasto $\langle{\tt return}\rangle$, inizia una pagina
nuova anche sul file grafico.

\ccall
pagina();
\endccall
\limit
Il sottoprogramma {\tt pagina} non deve essere richiamato all'$\,$inizio
del programma, poich\'e la prima pagina viene aperta dal
sottoprogramma {\tt inizio}.

Nella versione attuale si pu\`o cancellare qualunque pagina; tuttavia
viene iniziata in ogni caso una pagina nuova.  Se la cancellazione
viene eseguita immediatamente prima della chiamata al sottoprogramma
{\tt fine} rester\`a comunque una pagina vuota alla fine del file
grafico.

\note La generazione di una nuova pagina pu\`o farsi anche col
sottoprogramma {\tt canpag}.  I due sottoprogrammi sono molto simili.
La differenza \`e che in mancanza di un input ben definito (ossia uno
dei caratteri `{\tt c}', `{\tt C}', `{\tt n}', `{\tt N}', `{\tt s}',
`{\tt S}', `{\tt y}' o `{\tt Y}') {\tt pagina} assume che la pagina
sul file grafico debba essere mantenuta, mentre {\tt canpag} assume
che debba essere cancellata.
