\scheda{penna}
\tipo{S}
\scopo
Cambia la penna del plotter.

\ccall
penna(k)
int k;
\endccall

\param
\prm{k}Variabile o costante intera che specifica il 
numero della penna da usare.

\limit
{\tt k} deve essere positivo ed inferiore a 256.

\conderr
\errit{LGE\_PENNA}Il valore di {\tt k} non \`e corretto. 
La penna richiesta non \`e prevista.

\note
Il cambiamento di penna viene eseguito compatibilmente con il numero di
penne del plotter. Precisamente, se $n$ \`e il numero di penne
disponibili, viene usata la penna $j={\rm mod\,}(k-1,n)+1$. \`E inoltre
possibile stabilire una corrispondenza tra numero di penna usato nella
chiamata, e riportato su file grafico, e penna (reale o simulata) da
usare effettivamente. Questa scelta modifica la regola sopra enunciata.
Si veda a tal proposito il sottoprogramma {\tt defpen}.
\ina{Sottoprogramma>defpen}

