\scheda{quadro}
\tipo{S}
\scopo
Traccia quattro assi intorno all'$\,$area utente, completando con
scala ed eventuali etichette l'$\,$asse inferiore e quello di sinistra.

\ccall
quadro(testx,ntestx,testy,ntesty)
char testx[],testy[];
int ntestx,ntesty;
\endccall
\param
\prm{testx}Stringa di caratteri contenente l'$\,$etichetta
dell'$\,$asse $x$.
\prm{ntestx}Variabile o costante intera contenente la
lunghezza della stringa {\tt testx}.
\prm{testy}Stringa di caratteri contenente l'$\,$etichetta dell'$\,$asse 
$y$.
\prm{ntesty}Variabile o costante intera contenente la
lunghezza della stringa {\tt testy}.

\limit
Sono ammesse solo coordinate lineari o logaritmiche. Il sottoprogramma
deve essere richiamato solo dopo le definizioni dell'$\,$area grafica
(sottoprogramma {\tt grarea}), dell'$\,$area utente (sottoprogramma {\tt
utarea}) e del sistema di coordinate (sottoprogramma {\tt coord}). Ci\`o
in quanto gli estremi degli assi e della scala vengono definiti
direttamente dai limiti dell'$\,$area grafica e dell'$\,$area utente, 
mentre la scelta del tipo di asse (lineare o logaritmico) viene 
determinata tramite il sistema di coordinate in uso.

Per le stringhe di caratteri valgono le note riportate nella scheda 
del sottoprogramma {\tt stralf}.

\note
Le etichette possono essere eliminate ponendo ${\tt ntestx}=0$ e/o ${\tt
ntesty}=0$. La dimensione della scala e delle scritte viene posta a 2.
Per un controllo diretto si possono utilizzare i sottoprogrammi {\tt 
asse} per coordinate lineari e {\tt asslog} per coordinate logaritmiche.

