#! /bin/bash
# Salvataggio su dischetto zip 
if [ "${1}" == "" ]; then
    echo "Comando: ./salva.sh <directory di destinazione>"
    exit 1;
fi
ZIP="${1}"

if [ ! -d ${ZIP}/mizar ]; then
	 mkdir ${ZIP}/mizar
fi
cp -afvu salva.sh ${ZIP}/mizar
cp -afvu Istruzioni.txt ${ZIP}/mizar
#
if [ ! -d ${ZIP}/mizar/doc ]; then
	 mkdir ${ZIP}/mizar/doc
fi
cp -apvfu doc/Makefile ${ZIP}/mizar/doc/
cp -apvfu doc/Mizar.ps ${ZIP}/mizar/doc/
cp -apvfu doc/Mizar.tex ${ZIP}/mizar/doc/
cp -apvfu doc/formiz.tex ${ZIP}/mizar/doc/
cp -apvfu doc/formsch.tex ${ZIP}/mizar/doc/
cp -apvfu doc/gap0.tex ${ZIP}/mizar/doc/
cp -apvfu doc/cntr.tex ${ZIP}/mizar/doc/
cp -apvfu doc/opz.tex ${ZIP}/mizar/doc/
cp -apvfu doc/apperr.tex ${ZIP}/mizar/doc/
cp -apvfu doc/alfbet.sch ${ZIP}/mizar/doc/
cp -apvfu doc/angoli.sch ${ZIP}/mizar/doc/
cp -apvfu doc/angrid.sch ${ZIP}/mizar/doc/
cp -apvfu doc/asse.sch ${ZIP}/mizar/doc/
cp -apvfu doc/asslog.sch ${ZIP}/mizar/doc/
cp -apvfu doc/canpag.sch ${ZIP}/mizar/doc/
cp -apvfu doc/coord.sch ${ZIP}/mizar/doc/
cp -apvfu doc/defcar.sch ${ZIP}/mizar/doc/
cp -apvfu doc/defcen.sch ${ZIP}/mizar/doc/
cp -apvfu doc/defdrs.sch ${ZIP}/mizar/doc/
cp -apvfu doc/deferr.sch ${ZIP}/mizar/doc/
cp -apvfu doc/deffat.sch ${ZIP}/mizar/doc/
cp -apvfu doc/defftx.sch ${ZIP}/mizar/doc/
cp -apvfu doc/deffty.sch ${ZIP}/mizar/doc/
cp -apvfu doc/defgrl.sch ${ZIP}/mizar/doc/
cp -apvfu doc/defpag.sch ${ZIP}/mizar/doc/
cp -apvfu doc/defpen.sch ${ZIP}/mizar/doc/
cp -apvfu doc/defpun.sch ${ZIP}/mizar/doc/
cp -apvfu doc/defris.sch ${ZIP}/mizar/doc/
cp -apvfu doc/defrot.sch ${ZIP}/mizar/doc/
cp -apvfu doc/defsch.sch ${ZIP}/mizar/doc/
cp -apvfu doc/defsim.sch ${ZIP}/mizar/doc/
cp -apvfu doc/deftrt.sch ${ZIP}/mizar/doc/
cp -apvfu doc/fine.sch ${ZIP}/mizar/doc/
cp -apvfu doc/funrea.sch ${ZIP}/mizar/doc/
cp -apvfu doc/gmsgra.sch ${ZIP}/mizar/doc/
cp -apvfu doc/gmsrad.sch ${ZIP}/mizar/doc/
cp -apvfu doc/gradi.sch ${ZIP}/mizar/doc/
cp -apvfu doc/gragms.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grarea.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grcer.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grcur.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grmov.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grmovr.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grpun.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grpunr.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grseg.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grsegr.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grsim.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grsimr.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grtra.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grtrar.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grtrt.sch ${ZIP}/mizar/doc/
cp -apvfu doc/grtrtr.sch ${ZIP}/mizar/doc/
cp -apvfu doc/inizio.sch ${ZIP}/mizar/doc/
cp -apvfu doc/istogr.sch ${ZIP}/mizar/doc/
cp -apvfu doc/numesp.sch ${ZIP}/mizar/doc/
cp -apvfu doc/numint.sch ${ZIP}/mizar/doc/
cp -apvfu doc/numrea.sch ${ZIP}/mizar/doc/
cp -apvfu doc/pagina.sch ${ZIP}/mizar/doc/
cp -apvfu doc/paglim.sch ${ZIP}/mizar/doc/
cp -apvfu doc/penna.sch ${ZIP}/mizar/doc/
cp -apvfu doc/quadro.sch ${ZIP}/mizar/doc/
cp -apvfu doc/radgms.sch ${ZIP}/mizar/doc/
cp -apvfu doc/radian.sch ${ZIP}/mizar/doc/
cp -apvfu doc/stralf.sch ${ZIP}/mizar/doc/
cp -apvfu doc/utarea.sch ${ZIP}/mizar/doc/
cp -apvfu doc/utcer.sch ${ZIP}/mizar/doc/
cp -apvfu doc/utcoor.sch ${ZIP}/mizar/doc/
cp -apvfu doc/utcur.sch ${ZIP}/mizar/doc/
cp -apvfu doc/utmov.sch ${ZIP}/mizar/doc/
cp -apvfu doc/utmovr.sch ${ZIP}/mizar/doc/
cp -apvfu doc/utpun.sch ${ZIP}/mizar/doc/
cp -apvfu doc/utpunr.sch ${ZIP}/mizar/doc/
cp -apvfu doc/utseg.sch ${ZIP}/mizar/doc/
cp -apvfu doc/utsegr.sch ${ZIP}/mizar/doc/
cp -apvfu doc/utsim.sch ${ZIP}/mizar/doc/
cp -apvfu doc/utsimr.sch ${ZIP}/mizar/doc/
cp -apvfu doc/uttra.sch ${ZIP}/mizar/doc/
cp -apvfu doc/uttrar.sch ${ZIP}/mizar/doc/
cp -apvfu doc/uttrt.sch ${ZIP}/mizar/doc/
cp -apvfu doc/uttrtr.sch ${ZIP}/mizar/doc/
#
if [ ! -d ${ZIP}/mizar/lib ]; then
	 mkdir ${ZIP}/mizar/lib
fi
cp -apvfu lib/mizar.h ${ZIP}/mizar/lib/
cp -apvfu lib/bldcom ${ZIP}/mizar/lib/
cp -apvfu lib/bldfil ${ZIP}/mizar/lib/
cp -apvfu lib/bldint ${ZIP}/mizar/lib/
#
if [ ! -d ${ZIP}/mizar/src ]; then
	 mkdir ${ZIP}/mizar/src
fi
cp -apvfu src/Makefile ${ZIP}/mizar/src/
cp -apvfu src/Make_com ${ZIP}/mizar/src/
cp -apvfu src/Make_fil ${ZIP}/mizar/src/
cp -apvfu src/Make_icp ${ZIP}/mizar/src/
cp -apvfu src/Make_int ${ZIP}/mizar/src/
cp -apvfu src/assisc.c ${ZIP}/mizar/src/
cp -apvfu src/crinfo.c ${ZIP}/mizar/src/
cp -apvfu src/curliv.c ${ZIP}/mizar/src/
cp -apvfu src/genplt.c ${ZIP}/mizar/src/
cp -apvfu src/genrle.c ${ZIP}/mizar/src/
cp -apvfu src/grplot.c ${ZIP}/mizar/src/
cp -apvfu src/istogr.c ${ZIP}/mizar/src/
cp -apvfu src/mizcmn.c ${ZIP}/mizar/src/
cp -apvfu src/numeri.c ${ZIP}/mizar/src/
cp -apvfu src/stpdef.c ${ZIP}/mizar/src/
cp -apvfu src/stpiot.c ${ZIP}/mizar/src/
cp -apvfu src/stputl.c ${ZIP}/mizar/src/
cp -apvfu src/string.c ${ZIP}/mizar/src/
cp -apvfu src/utplot.c ${ZIP}/mizar/src/
cp -apvfu src/icpcmn.c ${ZIP}/mizar/src/
cp -apvfu src/mizint.c ${ZIP}/mizar/src/
cp -apvfu src/pos.c    ${ZIP}/mizar/src/
cp -apvfu src/tek.c    ${ZIP}/mizar/src/
cp -apvfu src/tps.c    ${ZIP}/mizar/src/
cp -apvfu src/fgf.c    ${ZIP}/mizar/src/
cp -apvfu src/gd_icp.c ${ZIP}/mizar/src/
cp -apvfu src/ftn_f_interface.c ${ZIP}/mizar/src/
cp -apvfu src/ftn_d_interface.c ${ZIP}/mizar/src/
cp -apvfu src/inslib   ${ZIP}/mizar/src/
cp -apvfu src/libicp   ${ZIP}/mizar/src/
cp -apvfu src/bldicp   ${ZIP}/mizar/src/
cp -apvfu src/icpcmn.h ${ZIP}/mizar/src/
cp -apvfu src/mizcmn.h ${ZIP}/mizar/src/
cp -apvfu src/mizlocdf.h ${ZIP}/mizar/src/
cp -apvfu src/mizmsg.h ${ZIP}/mizar/src/
cp -apvfu src/crea_colori.c ${ZIP}/mizar/src/
cp -apvfu src/crea_colori.inp ${ZIP}/mizar/src/

#
if [ ! -d ${ZIP}/mizar/test ]; then
	 mkdir ${ZIP}/mizar/test
fi
cp -apvfu test/test.c        ${ZIP}/mizar/test/
cp -apvfu test/test_curliv.c ${ZIP}/mizar/test/
cp -apvfu test/test_funrea.c ${ZIP}/mizar/test/
cp -apvfu test/tavola.c      ${ZIP}/mizar/test/
cp -apvfu test/colori.c      ${ZIP}/mizar/test/
cp -apvfu test/ist_1.c       ${ZIP}/mizar/test/
cp -apvfu test/ist_2.c       ${ZIP}/mizar/test/
cp -apvfu test/Mizar_color_palette.dat ${ZIP}/mizar/test/
#
if [ ! -d ${ZIP}/mizar/util ]; then
	 mkdir ${ZIP}/mizar/util
fi
cp -apvfu util/makefile   ${ZIP}/mizar/util/
cp -apvfu util/lgbccr.h   ${ZIP}/mizar/util/
cp -apvfu util/mizdat.c   ${ZIP}/mizar/util/
cp -apvfu util/mizmsg.txt ${ZIP}/mizar/util/
#! end


