#! /bin/bash
# Salvataggio su dischetto zip 
ZIP="/media/ZIP-100" 

if [ ! -d ${ZIP}/mizar ]; then
	 mkdir ${ZIP}/mizar
fi
cp -afvu salvazip.sh ${ZIP}/mizar
cp -afvu Istruzioni.txt ${ZIP}/mizar
#
if [ ! -d ${ZIP}/mizar/doc ]; then
	 mkdir ${ZIP}/mizar/doc
fi
cp -avfu doc/Makefile ${ZIP}/mizar/doc/
cp -avfu doc/Mizar.ps ${ZIP}/mizar/doc/
cp -avfu doc/Mizar.tex ${ZIP}/mizar/doc/
cp -avfu doc/formiz.tex ${ZIP}/mizar/doc/
cp -avfu doc/formsch.tex ${ZIP}/mizar/doc/
cp -avfu doc/gap0.tex ${ZIP}/mizar/doc/
cp -avfu doc/cntr.tex ${ZIP}/mizar/doc/
cp -avfu doc/opz.tex ${ZIP}/mizar/doc/
cp -avfu doc/apperr.tex ${ZIP}/mizar/doc/
cp -avfu doc/alfbet.sch ${ZIP}/mizar/doc/
cp -avfu doc/angoli.sch ${ZIP}/mizar/doc/
cp -avfu doc/angrid.sch ${ZIP}/mizar/doc/
cp -avfu doc/asse.sch ${ZIP}/mizar/doc/
cp -avfu doc/asslog.sch ${ZIP}/mizar/doc/
cp -avfu doc/canpag.sch ${ZIP}/mizar/doc/
cp -avfu doc/coord.sch ${ZIP}/mizar/doc/
cp -avfu doc/defcar.sch ${ZIP}/mizar/doc/
cp -avfu doc/defcen.sch ${ZIP}/mizar/doc/
cp -avfu doc/defdrs.sch ${ZIP}/mizar/doc/
cp -avfu doc/deferr.sch ${ZIP}/mizar/doc/
cp -avfu doc/deffat.sch ${ZIP}/mizar/doc/
cp -avfu doc/defftx.sch ${ZIP}/mizar/doc/
cp -avfu doc/deffty.sch ${ZIP}/mizar/doc/
cp -avfu doc/defgrl.sch ${ZIP}/mizar/doc/
cp -avfu doc/defpag.sch ${ZIP}/mizar/doc/
cp -avfu doc/defpen.sch ${ZIP}/mizar/doc/
cp -avfu doc/defpun.sch ${ZIP}/mizar/doc/
cp -avfu doc/defris.sch ${ZIP}/mizar/doc/
cp -avfu doc/defrot.sch ${ZIP}/mizar/doc/
cp -avfu doc/defsch.sch ${ZIP}/mizar/doc/
cp -avfu doc/defsim.sch ${ZIP}/mizar/doc/
cp -avfu doc/deftrt.sch ${ZIP}/mizar/doc/
cp -avfu doc/fine.sch ${ZIP}/mizar/doc/
cp -avfu doc/funrea.sch ${ZIP}/mizar/doc/
cp -avfu doc/gmsgra.sch ${ZIP}/mizar/doc/
cp -avfu doc/gmsrad.sch ${ZIP}/mizar/doc/
cp -avfu doc/gradi.sch ${ZIP}/mizar/doc/
cp -avfu doc/gragms.sch ${ZIP}/mizar/doc/
cp -avfu doc/grarea.sch ${ZIP}/mizar/doc/
cp -avfu doc/grcer.sch ${ZIP}/mizar/doc/
cp -avfu doc/grcur.sch ${ZIP}/mizar/doc/
cp -avfu doc/grmov.sch ${ZIP}/mizar/doc/
cp -avfu doc/grmovr.sch ${ZIP}/mizar/doc/
cp -avfu doc/grpun.sch ${ZIP}/mizar/doc/
cp -avfu doc/grpunr.sch ${ZIP}/mizar/doc/
cp -avfu doc/grseg.sch ${ZIP}/mizar/doc/
cp -avfu doc/grsegr.sch ${ZIP}/mizar/doc/
cp -avfu doc/grsim.sch ${ZIP}/mizar/doc/
cp -avfu doc/grsimr.sch ${ZIP}/mizar/doc/
cp -avfu doc/grtra.sch ${ZIP}/mizar/doc/
cp -avfu doc/grtrar.sch ${ZIP}/mizar/doc/
cp -avfu doc/grtrt.sch ${ZIP}/mizar/doc/
cp -avfu doc/grtrtr.sch ${ZIP}/mizar/doc/
cp -avfu doc/inizio.sch ${ZIP}/mizar/doc/
cp -avfu doc/istogr.sch ${ZIP}/mizar/doc/
cp -avfu doc/numesp.sch ${ZIP}/mizar/doc/
cp -avfu doc/numint.sch ${ZIP}/mizar/doc/
cp -avfu doc/numrea.sch ${ZIP}/mizar/doc/
cp -avfu doc/pagina.sch ${ZIP}/mizar/doc/
cp -avfu doc/paglim.sch ${ZIP}/mizar/doc/
cp -avfu doc/penna.sch ${ZIP}/mizar/doc/
cp -avfu doc/quadro.sch ${ZIP}/mizar/doc/
cp -avfu doc/radgms.sch ${ZIP}/mizar/doc/
cp -avfu doc/radian.sch ${ZIP}/mizar/doc/
cp -avfu doc/stralf.sch ${ZIP}/mizar/doc/
cp -avfu doc/utarea.sch ${ZIP}/mizar/doc/
cp -avfu doc/utcer.sch ${ZIP}/mizar/doc/
cp -avfu doc/utcoor.sch ${ZIP}/mizar/doc/
cp -avfu doc/utcur.sch ${ZIP}/mizar/doc/
cp -avfu doc/utmov.sch ${ZIP}/mizar/doc/
cp -avfu doc/utmovr.sch ${ZIP}/mizar/doc/
cp -avfu doc/utpun.sch ${ZIP}/mizar/doc/
cp -avfu doc/utpunr.sch ${ZIP}/mizar/doc/
cp -avfu doc/utseg.sch ${ZIP}/mizar/doc/
cp -avfu doc/utsegr.sch ${ZIP}/mizar/doc/
cp -avfu doc/utsim.sch ${ZIP}/mizar/doc/
cp -avfu doc/utsimr.sch ${ZIP}/mizar/doc/
cp -avfu doc/uttra.sch ${ZIP}/mizar/doc/
cp -avfu doc/uttrar.sch ${ZIP}/mizar/doc/
cp -avfu doc/uttrt.sch ${ZIP}/mizar/doc/
cp -avfu doc/uttrtr.sch ${ZIP}/mizar/doc/
#
if [ ! -d ${ZIP}/mizar/lib ]; then
	 mkdir ${ZIP}/mizar/lib
fi
cp -avfu lib/mizar.h ${ZIP}/mizar/lib/
cp -avfu lib/bldcom ${ZIP}/mizar/lib/
cp -avfu lib/bldfil ${ZIP}/mizar/lib/
cp -avfu lib/bldint ${ZIP}/mizar/lib/
#
if [ ! -d ${ZIP}/mizar/src ]; then
	 mkdir ${ZIP}/mizar/src
fi
cp -avfu src/Makefile ${ZIP}/mizar/src/
cp -avfu src/Make_com ${ZIP}/mizar/src/
cp -avfu src/Make_fil ${ZIP}/mizar/src/
cp -avfu src/Make_icp ${ZIP}/mizar/src/
cp -avfu src/Make_int ${ZIP}/mizar/src/
cp -avfu src/assisc.c ${ZIP}/mizar/src/
cp -avfu src/crinfo.c ${ZIP}/mizar/src/
cp -avfu src/curliv.c ${ZIP}/mizar/src/
cp -avfu src/genplt.c ${ZIP}/mizar/src/
cp -avfu src/genrle.c ${ZIP}/mizar/src/
cp -avfu src/grplot.c ${ZIP}/mizar/src/
cp -avfu src/istogr.c ${ZIP}/mizar/src/
cp -avfu src/mizcmn.c ${ZIP}/mizar/src/
cp -avfu src/numeri.c ${ZIP}/mizar/src/
cp -avfu src/stpdef.c ${ZIP}/mizar/src/
cp -avfu src/stpiot.c ${ZIP}/mizar/src/
cp -avfu src/stputl.c ${ZIP}/mizar/src/
cp -avfu src/string.c ${ZIP}/mizar/src/
cp -avfu src/utplot.c ${ZIP}/mizar/src/
cp -avfu src/icpcmn.c ${ZIP}/mizar/src/
cp -avfu src/mizint.c ${ZIP}/mizar/src/
cp -avfu src/pos.c    ${ZIP}/mizar/src/
cp -avfu src/tek.c    ${ZIP}/mizar/src/
cp -avfu src/tps.c    ${ZIP}/mizar/src/
cp -avfu src/fgf.c    ${ZIP}/mizar/src/
cp -avfu src/ftn_f_interface.c ${ZIP}/mizar/src/
cp -avfu src/ftn_d_interface.c ${ZIP}/mizar/src/
cp -avfu src/inslib   ${ZIP}/mizar/src/
cp -avfu src/libicp   ${ZIP}/mizar/src/
cp -avfu src/bldicp   ${ZIP}/mizar/src/
cp -avfu src/icpcmn.h ${ZIP}/mizar/src/
cp -avfu src/mizcmn.h ${ZIP}/mizar/src/
cp -avfu src/mizlocdf.h ${ZIP}/mizar/src/
cp -avfu src/mizmsg.h ${ZIP}/mizar/src/
cp -avfu src/crea_colori.c ${ZIP}/mizar/src/
cp -avfu src/crea_colori.inp ${ZIP}/mizar/src/

#
if [ ! -d ${ZIP}/mizar/test ]; then
	 mkdir ${ZIP}/mizar/test
fi
cp -avfu test/test.c        ${ZIP}/mizar/test/
cp -avfu test/test_curliv.c ${ZIP}/mizar/test/
cp -avfu test/test_funrea.c ${ZIP}/mizar/test/
cp -avfu test/tavola.c      ${ZIP}/mizar/test/
cp -avfu test/colori.c      ${ZIP}/mizar/test/
cp -avfu test/ist_1.c       ${ZIP}/mizar/test/
cp -avfu test/ist_2.c       ${ZIP}/mizar/test/
cp -avfu test/Mizar_color_palette.dat ${ZIP}/mizar/test/
#
if [ ! -d ${ZIP}/mizar/util ]; then
	 mkdir ${ZIP}/mizar/util
fi
cp -avfu util/makefile   ${ZIP}/mizar/util/
cp -avfu util/lgbccr.h   ${ZIP}/mizar/util/
cp -avfu util/mizdat.c   ${ZIP}/mizar/util/
cp -avfu util/mizmsg.txt ${ZIP}/mizar/util/
#! end


