#include <stdio.h>
#include <stdlib.h>
#define NUM_COLOR 256
#define MIZ_PALETTE_DEFAULT "Mizar_color_palette.dat"

unsigned short int Palette[NUM_COLOR][3];

int main()
{
  int j,j0,j1,cr0,cg0,cb0,cr1,cg1,cb1;
  double dr,dg,db,tmp,sgnr,sgng,sgnb;
  FILE *out;
  char *palette_name;

				/*  */
 fondo:
  printf("Colore di fondo (3 colori RGB, tra 0 e 255): ");
  scanf("%d %d %d",&cr0,&cg0,&cb0);
  if(cr0<0 || cr0 > 0377) {
    printf("Codice errato per il rosso: %d\n",cr0);
    goto fondo;
  }
  if(cg0<0 || cg0 > 0377) {
    printf("Codice errato per il verde: %d\n",cg0);
    goto fondo;
  }
  if(cb0<0 || cb0 > 0377) {
    printf("Codice errato per il blu: %d\n",cb0);
    goto fondo;
  }
  Palette[0][0] = cr0;  Palette[0][1] = cg0;  Palette[0][2] = cb0;  
				/*  */
 primo:
  printf("Primo colore (3 colori RGB, tra 0 e 255): ");
  scanf("%d %d %d",&cr0,&cg0,&cb0);
  if(cr0<0 || cr0 > 0377) {
    printf("Codice errato per il rosso: %d\n",cr0);
    goto primo;
  }
  if(cg0<0 || cg0 > 0377) {
    printf("Codice errato per il verde: %d\n",cg0);
    goto primo;
  }
  if(cb0<0 || cb0 > 0377) {
    printf("Codice errato per il blu: %d\n",cb0);
    goto primo;
  }
  Palette[1][0] = cr0;  Palette[1][1] = cg0;  Palette[1][2] = cb0;  
				/*  */
  printf("Ora definisci gli intervalli da riempire con continuita'.\n");
  printf("Ogni intervallo inizia col colore corrente e termina con\n");
  printf("quello di arrivo specificato, e col colore specificato.\n");
  printf("La palette puo' contenere al massimo %d elementi.\n",NUM_COLOR-1);
  j0=1;
 altri:
  printf("\nColore corrente %d: R=%d, G=%d; B=%d\n",
	 j0,Palette[j0][0],Palette[j0][1],Palette[j0][2]);
  printf("Fino a (indice,R,G,B): ");
  scanf("%d %d %d %d",&j1,&cr1,&cg1,&cb1);
  if(j1<=0) goto concludi;
  if(j1>NUM_COLOR) {
    printf("Indice errato: %d",j1);
    goto altri;
  }
  if(cr1<0 || cr1 > 0377) {
    printf("Codice errato per il rosso: %d\n",cr0);
    goto altri;
  }
  if(cg1<0 || cg1 > 0377) {
    printf("Codice errato per il verde: %d\n",cg0);
    goto altri;
  }
  if(cb1<0 || cb1 > 0377) {
    printf("Codice errato per il blu: %d\n",cb0);
    goto altri;
  }
  tmp = 1./((double) (j1-j0));
  dr = ((double) (cr1-cr0))*tmp;  sgnr = (dr>=0)? .5 : -.5;
  dg = ((double) (cg1-cg0))*tmp;  sgng = (dg>=0)? .5 : -.5;
  db = ((double) (cb1-cb0))*tmp;  sgnb = (db>=0)? .5 : -.5;
  for(j=1; j<=(j1-j0); j++) {
    cr1 = cr0+j*dr+sgnr;  if(cr1<0) cr1=0;  if(cr1>255) cr1=255; 
    cg1 = cg0+j*dg+sgng;  if(cg1<0) cg1=0;  if(cg1>255) cg1=255; 
    cb1 = cb0+j*db+sgnb;  if(cb1<0) cb1=0;  if(cb1>255) cb1=255; 
    Palette[j+j0][0] = cr1;
    Palette[j+j0][1] = cg1;
    Palette[j+j0][2] = cb1;
  }
  cr0 = cr1;  cg0 = cg1;  cb0 = cb1;
  if((j0=j1) < NUM_COLOR-1) goto altri;
				/*  */
 concludi:
  if(j0 < NUM_COLOR-1) {
    printf("Definisco i colori da %d a %d con valori di default.\n",j0+1,NUM_COLOR-1);
    for(j=1; j<NUM_COLOR-j0; j++) {
      Palette[j+j0][0] = Palette[j][0];
      Palette[j+j0][1] = Palette[j][1];
      Palette[j+j0][2] = Palette[j][2];
    }
  }
  palette_name = getenv("MIZAR_GIF_PALETTE");
  if(palette_name != NULL) {
    if((out=fopen(palette_name,"w")) == NULL) {
      printf("Errore in apertura del file-palette:\n");
      perror(palette_name);
      exit(1);
    }
  }
  else {
    if((out=fopen(MIZ_PALETTE_DEFAULT,"w")) == NULL) {
      printf("Errore in apertura del file-palette:\n");
      perror(MIZ_PALETTE_DEFAULT);
      exit(1);
    }
  }
  fwrite(Palette,sizeof(unsigned short int),3*NUM_COLOR,out);
  fclose(out);
  exit(0);
}
