/* <utplot> :
Sottoprogrammi di:
   -	definizione dell'area utente
   -	tracciamento in coordinate utente
*/
#include <stdio.h>
#include "mizlocdf.h"
#include "mizmsg.h"
#include "mizcmn.h"
extern struct lgbcge lgbcge;
extern struct lgbc2d lgbc2d;
/*  */
#define ABS(z) ((z)>=0)? (z):-(z)
/*  */
/* Sottoprogramma utarea */
INT utarea(xmin,xmax,ymin,ymax)
double xmin,xmax,ymin,ymax;
{  
/* Controllo delle condizioni di errore */
   if((xmin>=xmax) || (ymin>=ymax))
   {  lgerr(LGE_ESTREMIARUT);
      return(LGE_ESTREMIARUT);
   }
/* Chiamata valida. definisce l'area-utente. */
   lgbc2d.g2lim[MIZ_UTENTE][0]=xmin;
   lgbc2d.g2lim[MIZ_UTENTE][1]=xmax;
   lgbc2d.g2lim[MIZ_UTENTE][2]=ymin;
   lgbc2d.g2lim[MIZ_UTENTE][3]=ymax;
/* Chiede di ridefinire i coefficienti di trasformazione */
   lgbc2d.kcodef=FALSE;
   return(0);
}
/* Sottoprogramma utmov */
INT utmov(x,y)
double x,y;
{  lgbc2d.kgrut=MIZ_UTENTE;
   return(lgplot(x,y,MIZ_MOV));
}
/* Sottoprogramma utseg */
INT utseg(x,y)
double x,y;
{  if(lgbc2d.kgrut!=MIZ_UTENTE) lgagrn(MIZ_UTENTE);
   lgbc2d.kgrut=MIZ_UTENTE;
   return(lgplot(x,y,MIZ_SEG));
}
/* Sottoprogramma utpun */
INT utpun(x,y)
double x,y;
{  lgbc2d.kgrut=MIZ_UTENTE;
   return(lgplot(x,y,MIZ_PUN));
}
/* Sottoprogramma utsim */
INT utsim(x,y)
double x,y;
{  lgbc2d.kgrut=MIZ_UTENTE;
   return(lgplot(x,y,MIZ_SIM));
}
/* Sottoprogramma uttrt */
INT uttrt(x,y)
double x,y;
{  if(lgbc2d.kgrut!=MIZ_UTENTE) lgagrn(MIZ_UTENTE);
   lgbc2d.kgrut=MIZ_UTENTE;
   return(lgplot(x,y,MIZ_TRA));
}
/* Sottoprogramma uttra */
INT uttra(x,y,modo)
double x,y;
INT modo[];
{  if(lgbc2d.kgrut!=MIZ_UTENTE) lgagrn(MIZ_UTENTE);
   lgbc2d.kgrut=MIZ_UTENTE;
   if(modo[0]!=0) deftrt(modo);
   return(lgplot(x,y,MIZ_TRA));
}
/* Sottoprogramma utmovr */
INT utmovr(x,y)
double x,y;
{  lgbc2d.kgrut=MIZ_UTENTE;
   return(lgplot(lgbc2d.g2ult[MIZ_UTENTE][0]+x,
   		lgbc2d.g2ult[MIZ_UTENTE][1]+y,MIZ_MOV));
}
/* Sottoprogramma utsegr */
INT utsegr(x,y)
double x,y;
{  if(lgbc2d.kgrut!=MIZ_UTENTE) lgagrn(MIZ_UTENTE);
   lgbc2d.kgrut=MIZ_UTENTE;
   return(lgplot(lgbc2d.g2ult[MIZ_UTENTE][0]+x,
   		lgbc2d.g2ult[MIZ_UTENTE][1]+y,MIZ_SEG));
}
/* Sottoprogramma utpunr */
INT utpunr(x,y)
double x,y;
{  lgbc2d.kgrut=MIZ_UTENTE;
   return(lgplot(lgbc2d.g2ult[MIZ_UTENTE][0]+x,
   		lgbc2d.g2ult[MIZ_UTENTE][1]+y,MIZ_PUN));
}
/* Sottoprogramma utsimr */
INT utsimr(x,y)
double x,y;
{  lgbc2d.kgrut=MIZ_UTENTE;
   return(lgplot(lgbc2d.g2ult[MIZ_UTENTE][0]+x,
   		lgbc2d.g2ult[MIZ_UTENTE][1]+y,MIZ_SIM));
}
/* Sottoprogramma uttrtr */
INT uttrtr(x,y)
double x,y;
{  if(lgbc2d.kgrut!=MIZ_UTENTE) lgagrn(MIZ_UTENTE);
   lgbc2d.kgrut=MIZ_UTENTE;
   return(lgplot(lgbc2d.g2ult[MIZ_UTENTE][0]+x,
   		lgbc2d.g2ult[MIZ_UTENTE][1]+y,MIZ_TRA));
}
/* Sottoprogramma uttrar */
INT uttrar(x,y,modo)
double x,y;
INT modo[];
{  if(lgbc2d.kgrut!=MIZ_UTENTE) lgagrn(MIZ_UTENTE);
   lgbc2d.kgrut=MIZ_UTENTE;
   if(modo[0]!=0) deftrt(modo);
   return(lgplot(lgbc2d.g2ult[MIZ_UTENTE][0]+x,
   		lgbc2d.g2ult[MIZ_UTENTE][1]+y,MIZ_TRA));
}
