#include <stdio.h>
#include "mizar.h"
#define PX 1023.
#define PY 1023.
#define DGX 56.
#define DGY 84.
#define DG DGX
#define GXMIN 10.
#define GYMIN 10.
#define DIMTXT 1.5
#define NRIGHE 12
#define NCOLONNE 18
#define NCOLORI 216



int main()
{
  double x,y,xf,yf;
  int j,kpen,kr,kc,l,nl,kkk;
  nl = DG;
  inizio(0);
  defpag(1023.,1023.);
  for(j=0; j<NCOLORI; j++) {
    penna(j+1);
    kr = j/NCOLONNE;  kc = j%NCOLONNE;
    x = GXMIN+kc*DGX;  xf = x+DG;
    yf = GYMIN+(NRIGHE-kr)*DGY; y = yf-DG;
    for(l=0; l<nl; l++) {
      grmov(x,y+l);  grseg(xf,y+l);
    }
  }
				/*  */
  penna(1);
  xf = GXMIN+.5*(DGX-24*DIMTXT);
  yf = GYMIN+.5*(DGY-DG-11.*DIMTXT);
  for(j=0; j<NCOLORI; j++) {
    kr = j/NCOLONNE;  kc = j%NCOLONNE;
    x = kc*DGX+xf;   y = (NRIGHE-kr-1)*DGY+yf;
    numint(x,y,1,j+1,DIMTXT,0.,&kkk);
  }
				/*  */
  x = GXMIN;  xf = x+NCOLONNE*DGX;
  for(kr=0; kr<=NRIGHE; kr++) {
    y = GYMIN+kr*DGY;
    grmov(x,y);   grseg(xf,y);
    if(kr<NRIGHE) {
      y += DGY-DG;
      grmov(x,y);   grseg(xf,y);
    }
  }
  y = GYMIN;   yf = y+NRIGHE*DGY;
  for(kc=0; kc<=NCOLONNE; kc++) {
    x = GXMIN+kc*DGX;
    utmov(x,y);   utseg(x,yf);
  }
  fine();
  exit(0);
}
