#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mizar.h"

#define NINTV 850
#define NDATI 1000000
#define SEED 0.91763245914
double Xvet[NDATI];
double Rint[NINTV];

int main()
{
  long double sum;
  double xmin, xmax, x;
  LONG j, itot, ibuoni;
  x = SEED;
  for(j=0; j<NDATI; j++) {
    x = fmod(1949.*x, 1.);
    sum += (Xvet[j] = x);
  }
  sum /= ((long double) NDATI);
  printf("media: %le", (double) sum);
  inizio(0);
  defpag(1023., 767.);
  grarea(100., 950., 100., 700.);
  xmin = 0.;  xmax = 1.;
  istogr(Xvet, NDATI, Rint, NINTV, 256,
	   &itot,&ibuoni,xmin,xmax,0.,0.,
	 "x",1,"Distribuzione",13);
  fine();
  return(0);
}
