/* Programma di test generale della libreria MiZaR */
#include <stdio.h>
#include <math.h>
#include <mizar.h>
void tstcr3();
void tstcr2();
void tstcr1();
void tstpen();
void tstlog();
void tstpol();
DOUBLE fdx();
/*  */
int main()
{  inizio(0);
   defpag(1023.,1023.);
/*   defbat(1) */
   tstpol();
   pagina();
   tstlog();
   pagina();
   tstpen();
   pagina();
   tstcr1();
   pagina();
   tstcr2();
   pagina();
   tstcr3();
   fine();
   return(0);
}
void tstpol()
/* Prova coordinate polari */
{  double  rag,ang,angpas;
   int i;
   angoli(1);
   coord(5);
   utarea(0.,100.,0.,360.);
/* Tracciamento dei raggi. */
   utmov(0.,0.);
   ang=0.;
   for(i=0;i<10;i++)
   {  utseg(100.,ang);
      ang+=18.;
      utmov(100.,ang);
      utseg(0.,ang);
      ang+=18.;
   }
/* Tracciamento dei cerchi */
   rag=20.;
   for(i=0;i<5;i++)
   {  angpas=50./rag;
      utmov(rag,0.);
      for(ang=0.;ang<=360.;ang+=angpas)
      {  utseg(rag,ang);
      }
      rag+=20.;
   }
   coord(1);
   return;
}
void tstlog()
/* Tracciamento di una griglia
in coordinate semilogaritmiche. */
{  double  y,ypas,x;
   int i,j;
   coord(3);
   utarea(0.,100.,1.,100.);
   y=1.;
   ypas=1.;
   for(j=0;j<2;j++)
   {  for(i=0;i<5;i++)
      {  utmov(0.,y);
	 utseg(100.,y);
	 y+=ypas;
	 utmov(100.,y);
	 utseg(0.,y);
	 y+=ypas;
      }
      ypas=10.;
      y=10.;
   }
   x=0.;
   for(i=0;i<10;i++)
   {  utmov(x,1.);
      utseg(x,100.);
      x+=5.;
      utmov(x,100.);
      utseg(x,1.);
      x=x+5.;
   }
   utmov(100.,1.);
   utseg(100.,100.);
   coord(1);
   return;
}
void tstpen()
/* Prova di diverse penne */
{  unsigned char car[256];
   int i,kkk;
   for(i=0;i<256;i++) car[i]=i;
   angoli(1);
   grmov(0.,0.);
   grseg(1023.,0.);
   grseg(1023.,1023.);
   grseg(0.,1023.);
   grseg(0.,0.);
   for(i=1;i<=16;i++)
   {  penna(i);
      grmov(50.,1000.-40*i);
      stralf("Scritta tracciata con la penna",30,2.,0.);
      numint(570.,1000.-40*i,1,(long) i,2.,0.,&kkk);
   }
   penna(1);
   grmov(50.,300.);
   stralf(&car[33],31,1.7,0.);
   grmov(50.,250.);
   stralf(&car[64],64,1.7,0.);
   grmov(50.,200.);
   stralf(&car[128],64,1.7,0.);
   grmov(50.,150.);
   stralf(&car[192],64,1.7,0.);
   grmov(900.,360.);
   penna(2);
   stralf("MiZaR",6,6.,90.);
   penna(1);
   return;
}
void tstcr1()
{  int ispo,i;
   double  ryx,dst,c;
   defpag(1023.,1200.);
   ispo=8;
   ryx=1.;
   for(i=0;i<21;i++)
   {  grmov(100.,1100.-i*50.);
      dst=-1.+.1*i;
      defcar(ispo,20,ryx,dst);
      stralf("La coda e' il sorriso del cane",30,2.,0.);
   }
   pagina();
   c=sqrt(21.);
   ispo=7;
   dst=0.;
   for(i=1;i<=21;i++)
   {  grmov(100.,1150.-i*50.);
      ryx=(c/i);
      defcar(ispo,20,ryx,dst);
      stralf("La coda e' il sorriso del cane",30,2.,0.);
   }
      pagina();

      dst=0.;
      ryx=1.;
      for(i=1;i<=21;i++)
      {  grmov(100.,1150.-i*50.);
	 ispo=(i>(22-i))? i/2:(22-i)/2;
	 ispo+=8;
	 defcar(ispo,20,ryx,dst);
         stralf("La coda e' il sorriso del cane",30,2.,0.);
      }
      return;
}
void tstcr2()
{  int i,j;
   defpag(1023.,1200.);
   retpag();
   defmar(100.,900.,100.,1100.);
   deftbo(0,-4);
   deftbv(0,-4);
   defcar(8,16,1.,0.);
   stralf("\014",1,2.,0.);
   for(j=0;j<4;j++)
   {  stralf("\013",1,2.,0.);
      for(i=0;i<3;i++)
      {  stralf("\011Colonna 1",10,2.,0.);
	 stralf("\011Colonna 2",10,2.,0.);
	 stralf("\011Colonna 3",10,2.,0.);
	 stralf("\011Colonna 4",10,2.,0.);
	 stralf("\017",1,2.,0.);
      }
   }
   return;
}
void tstcr3()
{  defpag(1023.,1200.);
   retpag();
   defmar(100.,900.,100.,1100.);
   deftbo(0,-2);
   defcar(8,50,1.,0.);
   stralf("\014",1,2.,0.);
   stralf("\011",1,2.,0.);
   stralf("a+b=b+a",100,2.,0.);
   stralf("\011",1,2.,0.);
   stralf("ab=ba",100,2.,0.);
   stralf("\017",1,2.,0.);
   stralf("\011",1,2.,0.);
   stralf("(a+b)+c=a+(b+c)",100,2.,0.);
   stralf("\011",1,2.,0.);
   stralf("(ab)c=a(bc)",100,2.,0.);
   stralf("\017",1,2.,0.);
   stralf("\011",1,2.,0.);
   stralf("0+a=a",100,2.,0.);
   stralf("\011",1,2.,0.);
   stralf("1a=a",100,2.,0.);
   stralf("\017",1,2.,0.);
   stralf("\011",1,2.,0.);
   stralf("a+(-a)=0",100,2.,0.);
   stralf("\011",1,2.,0.);
   stralf("aa\002-1\007=1",100,2.,0.);
   stralf("\017",1,2.,0.);
   stralf("a(b+c)=ab+ac",100,2.,0.);
   stralf("\017",1,2.,0.);
   stralf("a\002c\007b\002c\007=(ab)\002c",100,2.,0.);
   stralf("\017",1,2.,0.);
   stralf("a\002b\007a\002c\007=a\002b+c",100,2.,0.);
   stralf("\017",1,2.,0.);
   stralf("(a\002b\007)\002\002c\007\007=a\002bc",100,2.,0.);
   return;
}

/* Sottoprogramma che fornisce la funzione per il test di FUNREA */
DOUBLE fdx(x)
double x;
{  double  a;
   a=31.4159326*x*x*x*x*x;
   a=sin(a);
   return(a);
}
